#ifndef IO_H_INCLUDED
#define IO_H_INCLUDED

#include "TS.h"

extern volatile u8 joy_status;
extern volatile u8 kursor_status;

#define JOY_UP      1 << 3
#define JOY_DOWN    1 << 2
#define JOY_LEFT    1 << 1
#define JOY_RIGHT   1 << 0
#define JOY_FIRE    1 << 4

#define JOY_ISUP    (joy_status & JOY_UP)
#define JOY_ISDOWN  (joy_status & JOY_DOWN)
#define JOY_ISLEFT  (joy_status & JOY_LEFT)
#define JOY_ISRIGHT (joy_status & JOY_RIGHT)
#define JOY_ISFIRE  (joy_status & JOY_FIRE)

#define CURSOR_ISUP    (kursor_status & JOY_UP)
#define CURSOR_ISDOWN  (kursor_status & JOY_DOWN)
#define CURSOR_ISLEFT  (kursor_status & JOY_LEFT)
#define CURSOR_ISRIGHT (kursor_status & JOY_RIGHT)
#define CURSOR_ISFIRE  (kursor_status & JOY_FIRE)

#define ROW_1_5     0xF7
#define ROW_6_0     0xEF
#define ROW_Q_T     0xFB
#define ROW_Y_P     0xDF
#define ROW_A_G     0xFD
#define ROW_H_ENTER 0xBF
#define ROW_CS_V    0xFE
#define ROW_B_SPACE 0x7F

__sfr __banked __at ((ROW_1_5 << 8) | 0xFE)     KEYS_1_5;
__sfr __banked __at ((ROW_6_0 << 8) | 0xFE)     KEYS_6_0;
__sfr __banked __at ((ROW_Q_T << 8) | 0xFE)     KEYS_Q_T;
__sfr __banked __at ((ROW_Y_P << 8) | 0xFE)     KEYS_Y_P;
__sfr __banked __at ((ROW_A_G << 8) | 0xFE)     KEYS_A_G;
__sfr __banked __at ((ROW_H_ENTER << 8) | 0xFE) KEYS_H_ENTER;
__sfr __banked __at ((ROW_CS_V << 8) | 0xFE)    KEYS_CS_V;
__sfr __banked __at ((ROW_B_SPACE << 8) | 0xFE) KEYS_B_SPACE;


void PauseProcess();
void JoyProcess();
void KeyProcess();

#endif // IO_H_INCLUDED
