#ifndef SCREEN_H_INCLUDED
#define SCREEN_H_INCLUDED

#include "TS.h"

#define pad_left    1
#define pad_width   14
#define pad_top     1
#define pad_height  22

#define T_BORDER    TILE_INFO(0,0,3,7)
#define T_NONE      TILE_INFO(0,0,3,0)
#define T_SCORE     TILE_INFO(0,0,3,2)

__at (0xC000) u8  tiles[8][64][4];       //y,x,tile
__at (0xC000) u16 tilemap[64][2][64];    //y,plane,x

extern const u8 pattern[8];
extern const u8 digits[10][5][3];
extern const u8 logo_pattern[5][24];


typedef struct
{
    u8 W;
    u8 H;
} Size;

void CreateTiles();
void SetVMode();
void ClearScreen();
void DrawDigit(u8 pos_x, u8 pos_y, u8 value, u8 color);
void DrawRect(u8 left, u8 top, u8 width, u8 height, u8 color);
void DrawFillRect(u8 left, u8 top, u8 width, u8 height, u8 color);
void DrawTileShape(u8 pos_x, u8 pos_y, u8 shape, u8 rotate, u8 color);

#endif // SCREEN_H_INCLUDED
